


<script>

export default {

	data () {
		/*
			// const buffer = new ArrayBuffer (8);
		*/
		
		var uint_8_array = new Uint8Array (57);
		
		return {
			input: 0,
			
			max: BigInt ([
				"0x",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF",
				"FFFFFFFFFFFFFFFF"
			].join ("")),
			
			max_array_value: 0xFFFFFFFFFFFF,
			arrays: [
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF,
				0xFFFFFFFFFFFF				
			]
		}
	},
	
	watch: {
		input (input) {
			console.log ('input changed', { input })
			
			console.log (typeof input)
			
			var big_int = BigInt (parseFloat (input))
			console.log ({ big_int })
			console.log (big_int.toString (16))
		}
	},
	
	methods: {
		arrays_to_hexadecimal () {
			const arrays = this.arrays;
			
			var string = ""
			for (let s = 0; s < arrays.length; s++) {
				string += this.twelve_to16String (arrays [s])
			}
			
			return string
		},
		
		input_blur ({ $event, index }) {
			const value = $event.target.value;
			
			var value_integer;
			if (value === "") {
				value_integer = 0
			}
			else {
				value_integer = parseInt (value, 16) 
			}
			
			console.log ("input keydown", { value, value_integer })
			
			const { max_array_value } = this;
			if (value_integer >= max_array_value) {
				value_integer = max_array_value
			}
			else if (value_integer < 0) {
				value_integer = 0
			}
				
			this.arrays [ index ] = value_integer;
		},
		
		twelve_to16String (integer) {
			var amount = parseInt (integer).toString (16);
			
			var to_add = 12 - amount.length;
			console.log ({ to_add, integer })
			
			for (let s = 0; s < to_add; s++) {
				console.log ({ s })
				
				amount = "0" + amount;
			}
			
			return amount.toUpperCase ();
		},
		to16String (integer) {
			var amount = parseInt (integer).toString (16);
			
			if (amount.length === 1) {
				amount = "0" + amount;
			}
			
			return amount.toUpperCase ();
		},
		modify (index) {
			console.log ({ index })
		},
		range_modify ({ $event, index }) {
			const value = $event.target.value;
			
			console.log ({ index, $event })
		
			this.arrays [ index ] = parseFloat (value);
		
			console.log ('arrays:', this.arrays)
		},
		
		deliver () {
			console.log ('deliver')
		}
	}
}

</script>

<template>
	<main>
		<h1>Elliptic Key Production</h1>

		<p>Javascript Number.MAX_VALUE = {{ Number.MAX_VALUE }}</p>
		
		<p :style="{ wordWrap: 'break-word' }">ED448 Seed Max Value = {{ max }}</p>
		
		<p
			:style="{ wordWrap: 'break-word' }"
		>ED448 Seed Max Value = {{ parseInt (max) }}</p>
		
		<div />
		
		<button>generate</button>
		

	
		<div :style="{ height: '20px' }"/>		
		
		<p>arrays as base 16</p>
		<p 
			:style="{ 
				wordWrap: 'break-word',
				border: '2px solid #FFF',
				borderRadius: '8px',
				padding: '8px'
			}"
		>{{ arrays_to_hexadecimal (arrays) }}</p>
		
		<p>arrays: {{ arrays }}</p>
		
		<div
			v-for="(entry, index) in arrays"
			:style="{
				display: 'flex',
				padding: '5px 2px'
			}"
		>	
			<input
				:value="twelve_to16String (entry)"		
				:style="{
					display: 'inline-block',
					marginRight: '12px'
				}"
				@blur="input_blur ({ $event, index })"
			/>
		
			<input 
				:style="{ width: '100%' }"
				
				type="range"
				:value="entry"
				
				min="0"
				:max="max_array_value"
				
				@change="range_modify ({ $event, index })"
			/>
		</div>
		
		<div :style="{ height: '20px' }"/>
		
		<div
			v-for="(entry, index) in uint_8_array"
			:style="{
				display: 'inline-block',
				padding: '0 2px'
			}"
		>
			<input 
				:value="to16String (entry)"
				@keyup="modify (index)"
			/>
			
			{{ to16String (entry) }}
		</div>
		
		
		<div />
		

	</main>
</template>
